﻿///<reference path="../App.js" />		           
var urlPost = "/services/api/fund";


function make_base_auth(user, pass) {
	var tok = user + ':' + pass;

	var hash = $.base64.encode(tok);
	return "Basic " + hash;

}


$(function() {
	$(document).ready(function() {

		// var  _document = Office.context.document;
		//$("#docproperty").html(_document);
		// setData();    //Later for sensing Word or ExcelSheet
		if (localStorage.getItem("baseUrl") !== null) $("#url").val(localStorage.getItem("baseUrl"));

	});

});


function setData() {
	Office.context.document.bindings.addFromNamedItemAsync("A1", Office.BindingType.Text, {
		id: "MyBinding"
	}, function(asyncResult) {
		if (asyncResult.status == Office.AsyncResultStatus.Failed) {
			app.showNotification("unable to find cell", '');

		} else {

			Office.select("bindings#MyBinding").setDataAsync("ExcelSheet", {
				coercionType: "text"
			}, function(asyncResult) {
				if (asyncResult.status == "failed") {
					app.showNotification("Unable to insert", '');
				} else app.showNotification("Inserted !", '');

			});
		}

	});

}

function isValidEmailAddress(emailAddress) {
	var pattern = new RegExp(/^((([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+(\.([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+)*)|((\x22)((((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(([\x01-\x08\x0b\x0c\x0e-\x1f\x7f]|\x21|[\x23-\x5b]|[\x5d-\x7e]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(\\([\x01-\x09\x0b\x0c\x0d-\x7f]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]))))*(((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(\x22)))@((([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.)+(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.?$/i);
	return pattern.test(emailAddress);
}


function basicSignUp() {

	$('#notification-message').hide();

	if ($("#entry_986814855").val().trim() === "") {
		app.showNotification("Please enter the username !", '');
		return;
	} else if ($("#entry_2097667227").val().trim() === "") {
		app.showNotification("Please enter your fund's name !", '');
		return;
	} else if ($("#entry_1464001145").val().trim() === "" || !isValidEmailAddress($("#entry_1464001145").val().trim())) {
		app.showNotification("Please enter your email id !", '');
		return;
	}

	document.getElementById("signupForm").submit();
	window.location = "Success.html";
	
	/* $.ajax({
		url: "https://docs.google.com/forms/d/1MHv7Ii0VmPh2GkY43DN3m-6vk_5GpFNajT2bZdgMUS0/formResponse",
		method : "POST",
		success: function() {
          document.getElementById("signupForm").submit();
		},
		error: function(XMLHttpRequest, textStatus, errorThrown) {

			app.showNotification("Unable to process your request.", textStatus);
		}
	});
*/

}


function basicAuthentication() {

	$('#notification-message').hide();

	localStorage.removeItem('hashCode');

	var inputURL = $("#url").val().trim();


	if (inputURL.charAt(0) != "/" || inputURL !== "") {

		if (inputURL.slice(-1) === "/") {

			inputURL = inputURL.substring(0, inputURL.length - 1);
		}

		if (inputURL.substring(0, 5) != "https") {

			if (inputURL.substring(0, 4) != "http") inputURL = "https://" + inputURL;

			//	 else {
			//		 inputURL = "https://" + inputURL.substring(7, inputURL.length);
			//	 }
		}

	}

	var serviceURL = inputURL + urlPost;

	localStorage.setItem("url", serviceURL);

	if (inputURL !== "https://") localStorage.setItem("baseUrl", inputURL);

	var userName = $("#uname").val().trim();

	var passWord = $("#pwd").val().trim();

	if (userName === "") {
		app.showNotification("Please enter the user name", '');
		return;
	} else if (passWord === "") {
		app.showNotification("Please enter the password", '');
		return;
	}

	$("#loginIcon").removeClass();

	$("#loginIcon").addClass('glyphicon glyphicon-cog spin');

	var basicAuth = make_base_auth(userName, passWord);



	$.support.cors = true;

	if (localStorage.getItem("hashCode") === null) {




		$.ajax({
			type: "GET",
			headers: {          
				Accept: "application/json; charset=utf-8",         
				"Content-Type": "application/json; charset=utf-8"   
			  },     
			dataType: "json",

			crossDomain: true,
			url: serviceURL,
			beforeSend: function(xhr) {
				xhr.setRequestHeader("Authorization", basicAuth);
			},
			success: function(data) {
				localStorage.setItem("hashCode", basicAuth);
				document.getElementById("loginForm").submit();

			},

			error: function(XMLHttpRequest, textStatus, errorThrown) {

				app.showNotification("Unable to login", textStatus + errorThrown);
				$("#loginIcon").removeClass();
				$("#loginIcon").addClass('glyphicon glyphicon-log-in');



			}

		});

	} else {

		document.getElementById("loginForm").submit();


	}


}