﻿/// <reference path="../App.js" />	
var variable = "Select Group : ";
var objectVar = "Select Entity : ";
var propVar = "Select Entity Prop : ";

var preFix = "${";
var postFix = "}";
var preFunFix = "Select Function : ";
var postFunFix = "Select Entity or Group : ";

var ps = 0;
var preMetric = "${fw.m(";
var preCustomField = "${fw.c(";
var preContext = "${fw.v(";

var postContext = ")}";

var del1 = [];
var del2 = [];
var i = 0;
var a = 0;
var loopItems = "";
var loopVar = "-1";
var userName = "";
var passWord = "";
var isStart = "0";
var isStartIf = "0";
var urlPost = "/services/api/variable/category/all?fundId=";
var urlMetrics = "/services/api/metric/allMetrics";
var urlCustomFields = "/services/api/customfields/asset/fund/";
var fundURL = "/services/api/fund";
var entityURL = "https://www.getfundwave.com/tools/excel/reportbuilder/Entities.xml?v=22052020";
var fundId = "-1";

var customStorage;

var entityArray = [];
var entityObjArray = [];


$(function() {
	$(window).load(function() {
		app.initialize(); //important to load the m/s apis
		
		detectBrowser();
	    
	   
		if (localStorage.getItem("baseUrl") !== null) $("#url").val(localStorage.getItem("baseUrl"));
		$("#loading-icon").removeClass("loading-icon");
	});
});



  function detectBrowser(){
	  
	  "use strict";
     
	// Detecting IE
	
	var oldIE = false ;
	if ($('html').is('.ie6, .ie7, .ie8, .ie9')) {
		oldIE = true;
	}

	if (oldIE) {
		window.location = "Error.html";
	}
	
    
  }




function loadMainPage() {

	$("#content1").hide();
	$("#content2").hide();

	$("[name='my-checkbox']").bootstrapSwitch();
	$.fn.bootstrapSwitch.defaults.state = false;

	hideAll();
	//getData(18);
	//	document.getElementsByTagName("html")[0].style.visibility = "visible";
	$("#loading-icon").removeClass("loading-icon");
	$(".wrapper-class").show();

	getFunds();
	getEntity();

	$("#startDiv").html('<button class="btn btn-default pull-right insertLoop"><span class="glyphicon glyphicon-repeat"></span> Start Loop</button>');

	//   $('#entityBut').click(setSelectedCellEntity);
	$('#insertContext').click(setSelectedCellContext);
	$('#insertContext2').click(setSelectedCellContext2);
	$('#insertField').click(setSelectedCellField);

}

$(function() {

	$('input[name="my-checkbox"]').on('switchChange.bootstrapSwitch', function(event, state) {


		if (state === true) preContext = "${fw.nv(";
		else preContext = "${fw.v(";


	});
});

function setSelectedCellField() {


	var fieldCode;

	var fieldName = '"' + $("#customfield option:selected").attr("data-value") + '"';

	fieldCode = preCustomField + fieldName + ',asset' + postContext;

	$('#notification-message').hide();

	if (fieldName == '"Please select a custom field"') app.showNotification('In order to insert a custom field, please select a field', '');

	else {
		Office.context.document.setSelectedDataAsync(fieldCode, function(result) {


			if (result.status === Office.AsyncResultStatus.Succeeded) {

				app.showNotification('The inserted text is: ', '"' + fieldCode + '"');
			} else {

				app.showNotification('Error: ', "Unable to insert the selected text.");
			}
		});
	}



}

function setSelectedCellContext() {


	var j = i,
		setValue;

	var x = 0;

	var varContext = '"' + $("#variable option:selected").attr("data-value") + '"';

	var contextVal = varContext + ",";

	while (j > 0) {

		j--;


		if (del1.indexOf(j.toString()) < 0) {

			contextVal += $("#context1" + j + " option:selected").attr("data-value") + ",";
			if ($("#context1" + j + " option:selected").attr("data-value") == "Select a context") x = 1;

		}


	}
	contextVal = contextVal.substring(0, contextVal.length - 1);

	setValue = preContext + contextVal + postContext;

	$('#notification-message').hide();
	if (varContext == '"Please select a variable"') app.showNotification('In order to insert variable, please select a variable ', '');
	else if (x == 1) app.showNotification('In order to insert context, please select a context ', '');

	else {
		Office.context.document.setSelectedDataAsync(setValue, function(result) {


			if (result.status === Office.AsyncResultStatus.Succeeded) {

				app.showNotification('The inserted text is: ', '"' + setValue + '"');
			} else {

				app.showNotification('Error: ', "Unable to insert the selected text.");
			}
		});
	}

}

function setSelectedCellContext2() {


	var j = a,
		setValue;

	var x = 0;

	var varContext = '"' + $("#metric option:selected").attr("data-value") + '"';

	var contextVal = varContext + ",";

	while (j > 0) {

		j--;


		if (del2.indexOf(j.toString()) < 0) {

			contextVal += $("#context2" + j + " option:selected").attr("data-value") + ",";
			if ($("#context2" + j + " option:selected").attr("data-value") == "Select a context") x = 1;

		}


	}
	contextVal = contextVal.substring(0, contextVal.length - 1);

	setValue = preMetric + contextVal + postContext;

	$('#notification-message').hide();
	if (varContext == '"Please select a metric"') app.showNotification('In order to insert a metric, please select an option.', '');
	else if (x == 1) app.showNotification('In order to insert context, please select a context ', '');

	else {
		Office.context.document.setSelectedDataAsync(setValue, function(result) {


			if (result.status === Office.AsyncResultStatus.Succeeded) {

				app.showNotification('The inserted text is: ', '"' + setValue + '"');
			} else {

				app.showNotification('Error: ', "Unable to insert the selected text.");
			}
		});
	}



}

function setSelectedCellFunc() {

	var setValue;

	postFunFix = variable + "," + objectVar + ")}";

	setValue = preFunFix + postFunFix;

	Office.context.document.setSelectedDataAsync(setValue, function(result) {

	}

	);


}

function setSelectedCellEntity() {

	var setValue;
	$('#notification-message').hide();

	setValue = preFix + objectVar + "." + propVar + postFix;

	objectVar = "Select Entity : ";
	propVar = "Select Entity Prop : ";

	//	$('#eselect').prop('selectedIndex', 0);
	//	$('#entity').prop('selectedIndex', 0);
	Office.context.document.setSelectedDataAsync(setValue, function(result) {

		if (result.status === Office.AsyncResultStatus.Succeeded) {

			app.showNotification('The inserted text is:', '"' + setValue + '"');
		} else {

			app.showNotification('Error: ', "Unable to insert the selected text.");
		}

	}

	);


}

$(function() {
	$("#tab1").click(function() {

		$("#addButton").addClass("glyphicon glyphicon-plus");
		$("#addButton2").addClass("glyphicon glyphicon-plus");
		$("#refresh").addClass("glyphicon glyphicon-refresh");


	});

});

$(function() {


	$(document).on('click', '#refresh', function() {
		$('#notification-message').hide();

		if (fundId == "-1") {
			app.showNotification('Please select a fund from the funds box.', '');

			return;

		}

		$("#refresh").addClass("spin");

		$('#variable').html('<option data-value="Please select a variable" value="1">Please select a variable</option>');
		getData(fundId);
		getMetrics(fundId);
		getCustomFields(fundId);

	});

});

$(function() {


	$(document).on('click', '.refreshFundVariables', function() {



		$(".refreshFundVariables").addClass("spin");

		getFunds();

	});

});


$(function() {

	$(document).on('click', '#entityBut', function() {

		var setValue;

		$('#notification-message').hide();

		if (objectVar == "toDate" || objectVar == "fromDate") {

			setValue = preFix + objectVar + postFix;

			Office.context.document.setSelectedDataAsync(setValue, function(result) {

				if (result.status === Office.AsyncResultStatus.Succeeded) {

					app.showNotification('The inserted text is:', '"' + setValue + '"');
					return;
				} else {

					app.showNotification('Error: ', "Unable to insert the selected text.");
					return;
				}
			}


			);

		} else {


			propVar = "";
			for (var j = 0; j <= ps; j++) {

				if ($("#propertyService" + j + " option:selected").text() == "Please select a property") {

					app.showNotification('In order to insert an entity, please select a property', '');

					return;

				} else {
					propVar += $("#propertyService" + j + " option:selected").text() + ".";

				}

			}

			propVar = propVar.substring(0, propVar.length - 1);

			setValue = preFix + objectVar + "." + propVar + postFix;


			//	objectVar = "Select Entity : ";
			//	propVar = "Select Entity Prop : ";
			//   $('#eselect').prop('selectedIndex', 0);
			//	$('#entity').prop('selectedIndex', 0);
			if (objectVar == "Select Entity : ") app.showNotification('In order to insert an entity, please select an entity', '');


			else {
				Office.context.document.setSelectedDataAsync(setValue, function(result) {

					if (result.status === Office.AsyncResultStatus.Succeeded) {

						app.showNotification('The inserted text is:', '"' + setValue + '"');
					} else {

						app.showNotification('Error: ', "Unable to insert the selected text.");
					}
				}

				);
			}

		}
	});

});




$(function() {

	$("#tab3").click(function() {


		//	app.showNotification('Signing Out ........', '');
		localStorage.removeItem('url');
		localStorage.removeItem('hashCode');

		clearSession();


	});

});


function clearSession() {

	$('#notification-message').hide();
	localStorage.getItem("baseUrl");
	var outURL = localStorage.getItem("baseUrl") + "/j_spring_security_logout";

	$.ajax({
		url: outURL,
		type: 'POST',
		success: function(resp) {
			window.location = "Main.html";
			$("#loading-icon").removeClass("loading-icon");
			app.showNotification('Signing Out ........', '');
		},
		error: function(e) {
			$("#loading-icon").removeClass("loading-icon");
			window.location = "Main.html";
		}
	});


}


$(function() {

	$(document).on('change', '.propServ', function() {

		var id = $(this).attr("id").match(/\d+/);


		if (id != "0") $(this).parent().nextAll().remove();

		else if (id == "0") {

			$(".property-compound").html("");
			ps = 0;
		}

		ps = id;


		propVar = $(this).find('option:selected').text();

		if (propVar == "Please select a property") propVar = "Select Entity Prop : ";

		else if ($(this).find('option:selected').attr("hasProperties") == "yes") {

			ps++;
			$(".property-compound").append("<div class='form-group'><label for='propertyService" + ps + "'>Property</label>" + "<select class='form-control propServ' id='propertyService" + ps + "'><option>Please select a property</option></select></div>");


			getComplexProperty(ps, propVar);

		}


	});
});


function getComplexProperty(ps, selectedVar) {

	$('#notification-message').hide();
	var type, property;
	var serviceURL = entityURL;
	var basicAuth = customStorage;
	$.ajax({
		type: "GET",

		dataType: "xml",
		crossDomain: true,
		url: serviceURL,

		beforeSend: function(xhr) {
			xhr.setRequestHeader("Authorization", basicAuth);
		},
		success: function(data) {

			$("#propertyService" + ps).html("");
			$("#propertyService" + ps).html("<option>Please select a property</option>");


			$(data).find("ArrayOfEntities ComplexProperty").each(function() {


				type = $(this).find("Type").text();

				if (type === selectedVar) {


					$(this).find("Properties Property").each(function() {



						property = $(this).text();

						if ($(this).attr("hasProperties") === "yes") $("#propertyService" + ps).append("<option hasProperties='yes'>" + property + "</option>");
						else $("#propertyService" + ps).append("<option>" + property + "</option>");

					});


				}




			});




		},

		error: function(XMLHttpRequest, textStatus, errorThrown) {

			app.showNotification('Unable to load properties types : ', textStatus);
			$("#propertyService").html("");
			$("#propertyService").html("<option>Please select an entity first</option>");
		}

	});



}



$(function() {


	$(document).on('change', '#entityService', function() {


		$(".property-compound").html("");

		ps = 0;


		var selectedEntity = $(this).find('option:selected').text();

		objectVar = $(this).find('option:selected').attr("data-value");

		propVar = "Select Entity Prop : "; //reset property !important 
		if (selectedEntity == "Please select an entity") {

			objectVar = "Select Entity : ";


			$("#propertyService0").html("");
			$("#propertyService0").html("<option>Please select an entity first</option>");

			return;
		} else {


			$("#propertyService0").html("");
			$("#propertyService0").html("<option>Please select a property</option>");
			getProperty(selectedEntity);

		}



	});

});



function getProperty(selectedEntity) {


	$('#notification-message').hide();

	var type, property;
	var serviceURL = entityURL;
	var basicAuth = customStorage;
	$.ajax({
		type: "GET",

		dataType: "xml",
		crossDomain: true,
		url: serviceURL,

		beforeSend: function(xhr) {
			xhr.setRequestHeader("Authorization", basicAuth);
		},
		success: function(data) {

			$("#propertyService0").html("");
			$("#propertyService0").html("<option>Please select a property</option>");


			$(data).find("ArrayOfEntities Entity").each(function() {


				type = $(this).find("Type").text();

				if (type === selectedEntity) {


					$(this).find("Properties Property").each(function() {



						property = $(this).text();

						if ($(this).attr("hasProperties") === "yes") $("#propertyService0").append("<option hasProperties='yes'>" + property + "</option>");
						else $("#propertyService0").append("<option>" + property + "</option>");

					});


				}

			});

		},

		error: function(XMLHttpRequest, textStatus, errorThrown) {

			app.showNotification('Unable to load properties types : ', textStatus);
			$("#propertyService").html("");
			$("#propertyService").html("<option>Please select an entity first</option>");
		}

	});


}

/*

+ "<option data-value='Select a context'>Please select a context  </option> <option data-value='fund'>Fund</option> <option data-value='investor'>Investor</option>" + " <option data-value='partnership'>Partnership</option> <option data-value='asset'>Asset</option>" + "<option data-value='noticeGroup'>Notice Group</option> " + "<option data-value='investorType'>Investor Type</option>" + "<option data-value='fundTransactionType'>Fund Transaction Type</option>" + "<option data-value='fromDate'>From Date</option> <option data-value='toDate'>To Date</option>

*/

function renderContext() {

	$('#addr1' + i).html("<div class='row'><select id='context1" + i + "'class='col-xs-11'></select><span class='glyphicon glyphicon-minus-sign contBut1 col-xs-1' style='color:#808080;font-size:1.2em;top:6px !important; padding-left:3px !important' id='1" + i + "'></span></div>");

	$('#context1' + i).append("<option data-value='Select a context'>Please select a context</option>");

	for (var j = 0; j < entityArray.length; j++) {

		$('#context1' + i).append("<option data-value='" + entityObjArray[j] + "'>" + entityArray[j] + "</option>");

	}



	$('#tab_logic1').append("<div id='addr1" + (i + 1) + "'></div>");
	i++;
}

function renderContext2() {

	$('#addr2' + a).html("<div class='row'><select id='context2" + a + "'class='col-xs-11'></select><span class='glyphicon glyphicon-minus-sign contBut2 col-xs-1' style='color:#808080;font-size:1.2em;top:6px !important; padding-left:3px !important' id='2" + a + "'></span></div>");

	$('#context2' + a).append("<option data-value='Select a context'>Please select a context</option>");

	for (var j = 0; j < entityArray.length; j++) {

		$('#context2' + a).append("<option data-value='" + entityObjArray[j] + "'>" + entityArray[j] + "</option>");

	}

	$('#tab_logic2').append("<div id='addr2" + (a + 1) + "'></div>");
	a++;
}

$(function() {


	$("#addButtonDiv").click( renderContext );
	$("#addButtonDiv2").click( renderContext2 );

	$(document).on('click', '.contBut1', function() {

		var j = $(this).attr("id").replace("1","");

		if (j >= 0) {

			$("#addr1" + j).html('');

			del1.push(j);


		}

	});

	$(document).on('click', '.contBut2', function() {

		var j = $(this).attr("id").replace("2","");

		if (j >= 0) {

			$("#addr2" + j).html('');

			del2.push(j);


		}

	});

});



$(function() {
	$("#add").click(function() {

		$("#dynamic").append($("#box").html());

	});


});


$(function() {

	$(document).on('click', '.insertLoopEnd', function() {

		$('#notification-message').hide();
		if (isStart == "0") app.showNotification('Insert Loop Start', '');
		//	else getDimFromSelectionMatrix();
		else writeEnd();
	});

});

function writeEnd() {

	var rowEnd = '</jx:forEach>';
	$('#notification-message').hide();
	Office.context.document.setSelectedDataAsync(rowEnd, function(result) {


		if (result.status === Office.AsyncResultStatus.Succeeded) {
			isStart = "0";
			$("#endDiv").html('');
			$("#startDiv").html('<button class="btn btn-default pull-right insertLoop"><span class="glyphicon glyphicon-repeat"></span> Start Loop</button>');
			app.showNotification('The inserted text is:', '"' + rowEnd + '"');
		} else {

			app.showNotification('Error: ', "Unable to insert the selected text.");
		}

	});

}


$(function() {


	$(document).on('click', '.insertLoop', function() {

		$('#notification-message').hide();

		if (loopVar == "-1") app.showNotification('In order to start a loop, please select a entity below', '');

		//	else getDimFromSelectionMatrix();
		else writeBegin();
	});

});

function writeBegin() {

	$('#notification-message').hide();
	var rowStart = '<jx:forEach items="${' + loopItems + '}" var="' + loopVar + '">';
	Office.context.document.setSelectedDataAsync(rowStart, function(result) {


		if (result.status === Office.AsyncResultStatus.Succeeded) {
			isStart = "1";
			$("#startDiv").html('');
			$("#endDiv").html('<button class="btn btn-default pull-right insertLoopEnd"><span class="glyphicon glyphicon-stop"></span> End Loop</button>');

			app.showNotification('The inserted text is:', '"' + rowStart + '"');
		} else {

			app.showNotification('Error: ', "Unable to insert the selected text.");
		}

	});

}





$(function() {


	$(document).on('click', '#entityLoop', function() {



		if ($(this).find('option:selected').text() == "Please select an entity") {

			loopVar = "-1";

			return;

		}

		loopItems = $(this).find('option:selected').attr("data-value");
		loopVar = $(this).find('option:selected').attr("data-obj");



	})

});


$(function() {
	$("#remove").click(function() {

		$("#dynamic").removeChild();




	});


});

$(function() {


	$(document).on('click', '.dropdown-menu li', function() {

		$('#notification-message').hide();
		$(".selectedFundfromService").text($(this).text());

		fundId = $(this).attr("data-value");
		if (fundId == "-1") app.showNotification("In order to load variables please select correct fund.", '');

		else {

			$("#refresh").addClass("spin");

			$(".refreshFundVariables").addClass("spin");
			getData(fundId);
			getMetrics(fundId);
			getCustomFields(fundId);

		}
	});
});


function resetText() {

	$("#invest").text("Invest");
	$("#fund").text("Fund");

}

function hideAll() {


	$("#fundGrp").html('');

	$("#assetGrp").html('');
	$("#partGrp").html('');

	$("#investypeGrp").html('');

	$("#fttGrp").html('');

	$("#noticeGrp").html('');

	$("#investGrp").html('');

	$("#insert").hide();

	$("#myinsert").hide();


}

function hideAllIf() {


	$("#fundGrpIf").html('');

	$("#assetGrpIf").html('');
	$("#partGrpIf").html('');

	$("#investypeGrpIf").html('');

	$("#fttGrpIf").html('');

	$("#noticeGrpIf").html('');

	$("#investGrpIf").html('');




}





$.fn.sortOptions = function() {
	$(this).each(function() {
		var op = $(this).children("option");
		op.sort(function(a, b) {
			return a.text > b.text ? 1 : -1;
		})
		return $(this).empty().append(op);
	});
}


$.fn.sortLists = function() {
	$(this).each(function() {
		var op = $(this).children("li");
		op.sort(function(a, b) {
			return a.text > b.text ? 1 : -1;
		})
		return $(this).empty().append(op);
	});
}

function getEntity() {

	$('#notification-message').hide();
	var type, object, loopValue;
	var serviceURL = entityURL;
	var basicAuth = customStorage;

	$.ajax({
		type: "GET",

		dataType: "xml",
		crossDomain: true,
		url: serviceURL,
		beforeSend: function(xhr) {
			xhr.setRequestHeader("Authorization", basicAuth);
		},

		success: function(data) {

			entityArray.length = 0;
			entityObjArray.length = 0;

			$(data).find("ArrayOfEntities Entity").each(function() {

				type = $(this).find("Type").text();
				object = $(this).find("Object").text();
				loopValue = $(this).find("LoopValue").text();

				$("#entityService").append("<option data-value='" + object + "'>" + type + "</option>");

				if (loopValue !== "") $("#entityLoop").append("<option data-value='" + loopValue + "' data-obj='" + object + "'>" + type + "</option>");

				entityArray.push(type);
				entityObjArray.push(object);

			});




		},

		error: function(XMLHttpRequest, textStatus, errorThrown) {

			app.showNotification('Unable to load entity types : ', textStatus);

		}

	});




}




function getCustomFields(id) {

	$('#notification-message').hide();
	var name, code;

	var serviceURL = localStorage.getItem("baseUrl") + urlCustomFields  + id;//+ context;
	var basicAuth = customStorage;

	$.support.cors = true;



	$.ajax({
		headers: {          
			Accept: "application/json; charset=utf-8",         
			"Content-Type": "application/json; charset=utf-8"   
		  }, 
		dataType: "json",
		type: "GET",
		crossDomain: true,
		url: serviceURL,
		beforeSend: function(xhr) {
			xhr.setRequestHeader("Authorization", basicAuth);
		},
		success: function(data) {

			$('#customfield').html('');

			$('#customfield').html('<option data-value="Please select a custom field" value="1">Please select a custom field</option>');
			
			var customFieldsMap = JSON.parse(data.data);
		
			for (let key in customFieldsMap) {
				let name = customFieldsMap[key].Name;
				if (name && name.length>0)
					$("#customfield").append("<option data-value='" + name + "'>" + name + "</option>")
			}

			$("#customfield").sortOptions();
			$("#customfield").val("1");
			$("#refresh").removeClass("spin");
			$(".refreshFundVariables").removeClass("spin");
		},

		error: function(XMLHttpRequest, textStatus, errorThrown) {

			$('#customfield').html('');

			$('#customfield').html('<option data-value="Please select a custom field" value="1">Please select a custom field</option>');

			app.showNotification('Could not retrieve the custom fields for the entity ', errorThrown + ' : ' + textStatus);

			$("#refresh").removeClass("spin");
			$(".refreshFundVariables").removeClass("spin");
		}

	});

}

function getMetrics(id) {



	$('#notification-message').hide();
	var name, code;

	var serviceURL = localStorage.getItem("baseUrl") + urlMetrics;
	var basicAuth = customStorage;

	$.support.cors = true;



	$.ajax({
		type: "GET",

		dataType: "json",
		crossDomain: true,
		url: serviceURL,
		beforeSend: function(xhr) {
			xhr.setRequestHeader("Authorization", basicAuth);
		},
		success: function(data) {

			$('#metric').html('');

			$('#metric').html('<option data-value="Please select a metric" value="1">Please select a metric</option>');
			
			for (var i=0; i<data.metric.length; i++){
				var metric = data.metric[i];
				code = metric.code;
				name = metric.name;
				$("#metric").append("<option data-value='" + code + "'>" + name + "</option>")
			}

			$("#metric").sortOptions();
			$("#metric").val("1");
			$("#refresh2").removeClass("spin");
			$(".refreshMetrics").removeClass("spin");
		},

		error: function(XMLHttpRequest, textStatus, errorThrown) {

			$('#metric').html('');

			$('#metric').html('<option data-value="Please select a metric" value="1">Please select a metric</option>');

			app.showNotification('Could not retrieve the metrics for the asset ', errorThrown + ' : ' + textStatus);

			$("#refresh2").removeClass("spin");
			$(".refreshMetrics").removeClass("spin");
		}

	});

}


function getData(id) {



	$('#notification-message').hide();
	var name, code;

	var serviceURL = localStorage.getItem("baseUrl") + urlPost + id;
	var basicAuth = customStorage;

	$.support.cors = true;



	$.ajax({
		type: "GET",

		dataType: "xml",
		crossDomain: true,
		url: serviceURL,
		beforeSend: function(xhr) {
			xhr.setRequestHeader("Authorization", basicAuth);
		},
		success: function(data) {

			$('#variable').html('');

			$('#variable').html('<option data-value="Please select a variable" value="1">Please select a variable</option>');
			$(data).find("VariableTree Variable").each(function() {

				code = $(this).find("Code").text();
				name = $(this).find("Name").text();

				$("#variable").append("<option data-value='" + code + "'>" + name + "</option>")


			});


			$("#variable").sortOptions();
			$("#variable").val("1");
			$("#refresh").removeClass("spin");
			$(".refreshFundVariables").removeClass("spin");
		},

		error: function(XMLHttpRequest, textStatus, errorThrown) {

			$('#variable').html('');

			$('#variable').html('<option data-value="Please select a variable" value="1">Please select a variable</option>');

			app.showNotification('Could not retrieve the variables for the fund ', errorThrown + ' : ' + textStatus);

			$("#refresh").removeClass("spin");
			$(".refreshFundVariables").removeClass("spin");
		}

	});

}



$(function() {

	$(document).on('change', '#fundService', function() {

		$('#notification-message').hide();
		fundId = $(this).find('option:selected').attr("data-value");


		if (fundId == "-1") {
			app.showNotification("In order to get the variables, please select the funds", '');
			return;
		}
		$("#refresh").addClass("spin");
		getData(fundId);
		getCustomFields(fundId);
		getMetrics(fundId);

	});
});

function getFunds() {


	var fundName, id;
	$('#notification-message').hide();
	var serviceURL = localStorage.getItem("baseUrl") + fundURL;
	var basicAuth = customStorage;

	$.support.cors = true;

	$.ajax({
		type: "GET",
		headers: {          
			Accept: "application/json; charset=utf-8",         
			"Content-Type": "application/json; charset=utf-8"   
		  }, 
		dataType: "json",
		crossDomain: true,
		url: serviceURL,
		beforeSend: function(xhr) {
			xhr.setRequestHeader("Authorization", basicAuth);
		},
		success: function(data) {

			$(".dropdown-menu").html('');


			$('#fundService').html('');
			$('#fundService').html('<option data-value="Please select a fund" value="-1" data-value="-1 class="fundColor">Please select a fund</option>');

			for (var i=0; i<data.fund.length; i++){
				var fund = data.fund[i];
				id = fund.fundId;
				fundName = fund.fundName;
				$("#fundService").append("<option data-value='" + id + "' class='fundColor' >" + fundName + "</option>");
				$(".dropdown-menu").append("<li data-value='" + id + "'>" + fundName + "</li>");
			}

			$(".dropdown-menu").sortLists();
			$("#fundService").sortOptions();
			$("#fundService").val("-1");
			$("#fundService").addClass("fundColor");
			$("#refresh").removeClass("spin");
			$(".refreshFundVariables").removeClass("spin");
		},

		error: function(XMLHttpRequest, textStatus, errorThrown) {

			app.showNotification('Could not retrieve funds ', errorThrown + ' : ' + textStatus);

			$("#refresh").removeClass("spin");
			$(".refreshFundVariables").removeClass("spin");


		}

	});

}

function make_base_auth(user, pass) {
	var tok = user + ':' + pass;

	var hash = $.base64.encode(tok);
	return "Basic " + hash;

}



function setData() {
	Office.context.document.bindings.addFromNamedItemAsync("A1", Office.BindingType.Text, {
		id: "MyBinding"
	}, function(asyncResult) {
		if (asyncResult.status == Office.AsyncResultStatus.Failed) {
			app.showNotification("unable to find cell", '');

		} else {

			Office.select("bindings#MyBinding").setDataAsync("ExcelSheet", {
				coercionType: "text"
			}, function(asyncResult) {
				if (asyncResult.status == "failed") {
					app.showNotification("Unable to insert", '');
				} else app.showNotification("Inserted !", '');

			});
		}

	});

}

function isValidEmailAddress(emailAddress) {
	var pattern = new RegExp(/^((([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+(\.([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+)*)|((\x22)((((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(([\x01-\x08\x0b\x0c\x0e-\x1f\x7f]|\x21|[\x23-\x5b]|[\x5d-\x7e]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(\\([\x01-\x09\x0b\x0c\x0d-\x7f]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]))))*(((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(\x22)))@((([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.)+(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.?$/i);
	return pattern.test(emailAddress);
}


function basicSignUp() {

	$('#notification-message').hide();

	if ($("#entry_986814855").val().trim() === "") {
		app.showNotification("Please enter the username !", '');
		return;
	} else if ($("#entry_2097667227").val().trim() === "") {
		app.showNotification("Please enter your fund's name !", '');
		return;
	} else if ($("#entry_1464001145").val().trim() === "" || !isValidEmailAddress($("#entry_1464001145").val().trim())) {
		app.showNotification("Please enter your email id !", '');
		return;
	}

	document.getElementById("signupForm").submit();
	window.location = "Success.html";

	/* $.ajax({
		url: "https://docs.google.com/forms/d/1MHv7Ii0VmPh2GkY43DN3m-6vk_5GpFNajT2bZdgMUS0/formResponse",
		method : "POST",
		success: function() {
          document.getElementById("signupForm").submit();
		},
		error: function(XMLHttpRequest, textStatus, errorThrown) {

			app.showNotification("Unable to process your request.", textStatus);
		}
	});
*/

}


function basicAuthentication() {

	$('#notification-message').hide();

	var inputURL = $("#url").val().trim();


	if (inputURL.charAt(0) != "/" || inputURL !== "") {

		if (inputURL.slice(-1) === "/") {

			inputURL = inputURL.substring(0, inputURL.length - 1);
		}

		if (inputURL.substring(0, 5) != "https") {

			if (inputURL.substring(0, 4) != "http") inputURL = "https://" + inputURL;

			//	 else {
			//		 inputURL = "https://" + inputURL.substring(7, inputURL.length);
			//	 }
		}

	}

	var serviceURL = inputURL + fundURL;

	if (inputURL !== "https://") localStorage.setItem("baseUrl", inputURL);

	var userName = $("#uname").val().trim();

	var passWord = $("#pwd").val().trim();

	if (userName === "") {
		app.showNotification("Please enter the user name", '');
		return;
	} else if (passWord === "") {
		app.showNotification("Please enter the password", '');
		return;
	}

	$("#loginIcon").removeClass();

	$("#loginIcon").addClass('glyphicon glyphicon-cog spin');

	var basicAuth = make_base_auth(userName, passWord);
	customStorage = basicAuth;
	var actionURL = $("#loginForm").attr('action');
	var encodedParam = encodeURIComponent(basicAuth);
	console.log(encodedParam);
	$('#loginForm').attr('action', actionURL + "?" + encodedParam);
	$.support.cors = true;

	$.ajax({
		type: "GET",
		headers: {          
			Accept: "application/json; charset=utf-8",         
			"Content-Type": "application/json; charset=utf-8"   
		  }, 
		dataType: "json",

		crossDomain: true,
		url: serviceURL,
		beforeSend: function(xhr) {
			xhr.setRequestHeader("Authorization", basicAuth);
		},
		success: function(data) {

			document.getElementById("loginForm").submit();
		},

		error: function(XMLHttpRequest, textStatus, errorThrown) {

			app.showNotification("Error : ", "Unable to login. Please verify your credentials.");
			$("#loginIcon").removeClass();
			$("#loginIcon").addClass('glyphicon glyphicon-log-in');



		}

	});



}


function make_base_auth(user, pass) {
	var tok = user + ':' + pass;

	var hash = $.base64.encode(tok);
	return "Basic " + hash;

}


$(function() {
	$(document).ready(function() {

		if (localStorage.getItem("baseUrl") !== null) $("#url").val(localStorage.getItem("baseUrl"));

	});

});

$(function() {

	$(document).on("click", "#backToLogin", function() {

		window.location = "Main.html";


	});


});


function setData() {
	Office.context.document.bindings.addFromNamedItemAsync("A1", Office.BindingType.Text, {
		id: "MyBinding"
	}, function(asyncResult) {
		if (asyncResult.status == Office.AsyncResultStatus.Failed) {
			app.showNotification("unable to find cell", '');

		} else {

			Office.select("bindings#MyBinding").setDataAsync("ExcelSheet", {
				coercionType: "text"
			}, function(asyncResult) {
				if (asyncResult.status == "failed") {
					app.showNotification("Unable to insert", '');
				} else app.showNotification("Inserted !", '');

			});
		}

	});

}

function isValidEmailAddress(emailAddress) {
	var pattern = new RegExp(/^((([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+(\.([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+)*)|((\x22)((((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(([\x01-\x08\x0b\x0c\x0e-\x1f\x7f]|\x21|[\x23-\x5b]|[\x5d-\x7e]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(\\([\x01-\x09\x0b\x0c\x0d-\x7f]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]))))*(((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(\x22)))@((([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.)+(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.?$/i);
	return pattern.test(emailAddress);
}


function basicSignUp() {

	$('#notification-message').hide();

	if ($("#entry_986814855").val().trim() === "") {
		app.showNotification("Please enter your name !", '');
		return;
	} else if ($("#entry_2097667227").val().trim() === "") {
		app.showNotification("Please enter your fund's name !", '');
		return;
	} else if ($("#entry_1464001145").val().trim() === "" || !isValidEmailAddress($("#entry_1464001145").val().trim())) {
		app.showNotification("Please enter your email id !", '');
		return;
	}

	document.getElementById("signupForm").submit();
	window.location = "Success.html";

	/* $.ajax({
		url: "https://docs.google.com/forms/d/1MHv7Ii0VmPh2GkY43DN3m-6vk_5GpFNajT2bZdgMUS0/formResponse",
		method : "POST",
		success: function() {
          document.getElementById("signupForm").submit();
		},
		error: function(XMLHttpRequest, textStatus, errorThrown) {

			app.showNotification("Unable to process your request.", textStatus);
		}
	});
*/

}


function basicAuthentication() {

	$('#notification-message').hide();

	var inputURL = $("#url").val().trim();


	if (inputURL.charAt(0) != "/" || inputURL !== "") {

		if (inputURL.slice(-1) === "/") {

			inputURL = inputURL.substring(0, inputURL.length - 1);
		}

		if (inputURL.substring(0, 5) != "https") {

			if (inputURL.substring(0, 4) != "http") inputURL = "https://" + inputURL;

			//	 else {
			//		 inputURL = "https://" + inputURL.substring(7, inputURL.length);
			//	 }
		}

	}

	var serviceURL = inputURL + fundURL;

	if (inputURL !== "https://") localStorage.setItem("baseUrl", inputURL);

	var userName = $("#uname").val().trim();

	var passWord = $("#pwd").val().trim();

	if (userName === "") {
		app.showNotification("Please enter the user name", '');
		return;
	} else if (passWord === "") {
		app.showNotification("Please enter the password", '');
		return;
	}

	$(".home-page").hide();
	$("#loading-icon").addClass("loading-icon");

	$("#loginIcon").removeClass();

	$("#loginIcon").addClass('glyphicon glyphicon-cog spin');

	var basicAuth = make_base_auth(userName, passWord);
	customStorage = basicAuth;

	$.support.cors = true;

	$.ajax({
		type: "GET",
		headers: {          
			Accept: "application/json; charset=utf-8",         
			"Content-Type": "application/json; charset=utf-8"   
		  }, 
		dataType: "json",

		crossDomain: true,
		url: serviceURL,
		beforeSend: function(xhr) {
			xhr.setRequestHeader("Authorization", basicAuth);
		},
		success: function(data) {
			$("#loading-icon").removeClass("loading-icon");
			$(".home-page").hide();
			$(".wrapper-class").show();
			loadMainPage();
			//document.getElementById("loginForm").submit();
		},

		error: function(XMLHttpRequest, textStatus, errorThrown) {
			$(".home-page").show();
			$("#loading-icon").removeClass("loading-icon");

			app.showNotification("Error : ", "Unable to login. Please enter correct credentials.");
			$("#loginIcon").removeClass();
			$("#loginIcon").addClass('glyphicon glyphicon-log-in');



		}

	});

}
