///<reference path="../App.js" />		
var urlPost = "/services/api/instance/ssoconfig";

$(function () {
    $(window).load(function () {
      app.initialize(); //important to load the m/s apis
  
      detectBrowser();

      if (localStorage.getItem("baseUrl")) {
        $("#url").val(localStorage.getItem("baseUrl"))
        if(localStorage.loginTypeRB === "sso" && localStorage.refreshTokenRB){
            window.location = "Main.html";
        }
          
        }
        else{
            localStorage.clear();
            sessionStorage.clear();
        }
  
  
      
      });
  });


  function detectBrowser() {

    "use strict";
  
    // Detecting IE
  
    var oldIE = false;
    if ($('html').is('.ie6, .ie7, .ie8, .ie9')) {
      oldIE = true;
    }
  
    if (oldIE) {
      window.location = "Error.html";
    }
  
  
  }


function ssoConfig() {

        $('#notification-message').hide();
    
        localStorage.removeItem('hashCode');
    
        var inputURL = $("#url").val().trim();
        if (inputURL === "") {
            app.showNotification("Please enter valid service URL.", '');
            return;
        }
    
        if (inputURL.charAt(0) != "/" || inputURL !== "") {
    
            if (inputURL.slice(-1) === "/") {
    
                inputURL = inputURL.substring(0, inputURL.length - 1);
            }
    
            if (inputURL.substring(0, 5) != "https") {
    
                if (inputURL.substring(0, 4) != "http") inputURL = "https://" + inputURL;
    
                //	 else {
                //		 inputURL = "https://" + inputURL.substring(7, inputURL.length);
                //	 }
            }
    
        }
    
        var serviceURL = inputURL + urlPost;
    
    
        if (inputURL !== "https://") localStorage.setItem("baseUrl", inputURL);
    
        localStorage.setItem("baseUrl", inputURL)
    

	$("#loginIcon").removeClass();

	$("#loginIcon").addClass('glyphicon glyphicon-cog spin');
    
        
    
    
    
    
            $.ajax({
                type: "GET",
    
                dataType: "json",
                contentType: "json",
                crossDomain: true,
                url: serviceURL,
                beforeSend: function(xhr) {
                    // xhr.setRequestHeader("Content-Type", 'application/json; charset=UTF-8');
                    xhr.setRequestHeader("Accept", 'application/json, text/javascript, */*; q=0.01');
                },
                success: function(data) {
                    if(data.ssoOnly){
                        localStorage.setItem("loginTypeRB", "sso")
                    }
                    else{
                        localStorage.setItem("loginTypeRB", "basic")
                    }
                    $("#loading-icon").removeClass("loading-icon");
                    document.getElementById("serviceUrlForm").submit();
    
                },
    
                error: function(XMLHttpRequest, textStatus, errorThrown) {
                    console.log("error")
                    // app.showNotification("Unable to login", textStatus + errorThrown);
                    $("#loginIcon").removeClass();
                    $("#loginIcon").addClass('glyphicon glyphicon-log-in');
    
    
    
                }
    
            });
    
        
    
    
    
}